var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { fetchData } from './utils';
var TKK = '0';
/* tslint:disable */
var tkkToTk = function (tkk, text) {
    var a = tkk.split('.');
    var t0 = Number(a[0]) || 0, t1 = Number(a[1]) || 0;
    var e = [];
    for (var f = 0, g = 0; g < text.length; g++) {
        var l = text.charCodeAt(g);
        128 > l ? e[f++] = l : (2048 > l ? e[f++] = l >> 6 | 192 : (55296 == (l & 64512) && g + 1 < text.length && 56320 == (text.charCodeAt(g + 1) & 64512) ? (l = 65536 + ((l & 1023) << 10) + (text.charCodeAt(++g) & 1023),
            e[f++] = l >> 18 | 240,
            e[f++] = l >> 12 & 63 | 128) : e[f++] = l >> 12 | 224,
            e[f++] = l >> 6 & 63 | 128),
            e[f++] = l & 63 | 128);
    }
    a = t0;
    for (var f = 0; f < e.length; f++) {
        a += e[f];
        a = xr(a, '+-a^+6');
    }
    a = xr(a, '+-3^+b+-f');
    a ^= t1;
    0 > a && (a = (a & 2147483647) + 2147483648);
    a %= 1E6;
    return (a.toString() + '.' + (a ^ t0));
};
var xr = function (a, b) {
    for (var c = 0; c < b.length - 2; c += 3) {
        var d = b.charAt(c + 2), d = 'a' <= d ? d.charCodeAt(0) - 87 : Number(d), d = '+' == b.charAt(c + 1) ? a >>> d : a << d;
        a = '+' == b.charAt(c) ? a + d & 4294967295 : a ^ d;
    }
    return a;
};
/* tslint:enable */
var updateTkk = function (com) { return __awaiter(void 0, void 0, void 0, function () {
    var now, url, res, text, code;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                now = Math.floor(Date.now() / 3600000);
                if (!(Number(TKK.split('.')[0]) === now)) return [3 /*break*/, 1];
                return [2 /*return*/];
            case 1:
                url = "https://translate.google." + (com ? 'com' : 'cn');
                return [4 /*yield*/, fetchData(url)];
            case 2:
                res = _a.sent();
                return [4 /*yield*/, res.text()];
            case 3:
                text = _a.sent();
                code = text.match(/tkk:.*?',/g);
                if (code) {
                    TKK = code[0].split('\'')[1];
                }
                _a.label = 4;
            case 4: return [2 /*return*/];
        }
    });
}); };
var getTk = function (text, com) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, updateTkk(com)];
            case 1:
                _a.sent();
                return [2 /*return*/, tkkToTk(TKK, text)];
        }
    });
}); };
export default getTk;
